{ Nevyeen problmy:                           }

unit Device;

{       Softwarov emulace poscriptu        }
{   Modul obsluhy fyz. vstupnho zazen  }
{           Tom Mayer(C) 1995             }

interface

uses Objects, WinTypes,WinProcs, OWindows, Hodnoty, ObjKomp, OPrinter, Strings;

{type PEmPrinter=^TEmPrinter;
     TEmPrinter=object(TPrinter)

                end;

type PEmPrintOut=^TEmPrintOut;
     TEmPrintOut=object(TPrintOut)

                 end;}

type POutputDevice=^TOutputDevice;
     TOutputDevice=object(TObject)
                    DXX,DXY,DXT,DYX,DYY,DYT:TReal;
                    constructor Init;
                    procedure SetCTMMatrix(AMatrix:PMatrix);
                    procedure Print(AWin:HWnd;ADC:HDC);
                   end;


implementation

function GetItem(var S:PChar):PChar;
 var i:integer;
 begin
  i:=0;
  while(S[i]<>',')and(S[i]<>#0) do inc(i);
  S[i]:=#0;
  GetItem:=S;
  if S[i+1]<>#0 then S:=@S[i+1];
 end;

constructor TOutputDevice.Init;
 begin
  inherited Init;
{ Tato definice plati pro monitor }
  DXX:=1;
  DXY:=0;
  DXT:=0;
  DYX:=0;
  DYY:=-1;
  DYT:=792;

{  DXX:=1;
  DXY:=0;
  DXT:=0;
  DYX:=0;
  DYY:=1;
  DYT:=0;}
 end;

procedure TOutputDevice.SetCTMMatrix(AMatrix:PMatrix);
 begin
  AMAtrix^.NewValue(DXX,DXY,DXT,DYX,DYY,DYT);
 end;

procedure TOutputDevice.Print(AWin:HWnd;ADC:HDC);
 var D,MemDC,ScreenDC:HDC;
     Info,TInfo:PChar;
     Driver,PrinterType,Port:PChar;
     OldBitmap,Bitmap:HBitmap;
     BM:TBitMap;
     W,H:integer;
 begin
  GetMem(Info,80);
  GetProfileString('Windows','Device',',,',Info,80);
  TInfo:=Info;
  Driver:=GetItem(Info);
  PrinterType:=GetItem(Info);
  Port:=GetItem(Info);
  D:=CreateDC(PrinterType,Driver,Port,nil);
  if D=0 then MessageBox(0,'Printer error','Printer',mb_ok);
  Escape(D,STARTDOC,8,StrNew('Graph page copy'),nil);
{  Escape(D,NEWFRAME,0,nil,nil);}
{  ScreenDC:=GetDC(AWin);
  MemDC:=CreateCompatibleDC(ScreenDC);
  ReleaseDC(AWin,ScreenDC);
  OldBitmap:=SelectObject(MemDC,Bitmap);
  GetObject(Bitmap,sizeof(BM),@BM);     }
  W:=GetDeviceCaps(D,HORZRES);
  H:=GetDeviceCaps(D,VERTRES);
  StretchBlt(D,0,0,W,H,ADC,0,0,576,792,SRCCOPY);
  Escape(D,NEWFRAME,0,nil,nil);
  Escape(D,ENDDOC,0,nil,nil);
  DeleteDC(D);
 end;

end.