{ Nevyeen problmy:                           }
{ Analyzator nepracuje s cisly v jinych soustavach 20#456 }

unit Lexikal;


{ Softwarov emulace poscriptu }
{    Lexikln analyztor      }
{    Tom Mayer (C) 1993      }

{$X+}

interface

  uses Objects,OWindows,OStdWnds,ObjKomp;

  const Tabel=#9;
  const wm_Activate    = $0006;
	wa_Active      = $0001;
	wa_CLickActive = $0002;


  var Retezec:array [0..255] of char;


type PFile=^TFile;
     TFile=object(TCompObject)
	    EdF:word; { zde se uchovava konstanta, ktera urcuje, zda se jedna o TFile nebo TEditFile }
	    Jmeno:array [0..40] of char; { nazev souboru }
	    TextBuff:array [0..1023] of char;
	    Konec:boolean;
	    Mode:word;
	    FileDescr:TDOSStream;
	    constructor Init(VMemory:PVirtMemory;FileN:PChar);
	    destructor Done; virtual;
	    procedure CtiRetezec; virtual;
	    function CtiZnak(var Znak:char):char; virtual;
	    procedure VratZnak(var Znak:char); virtual;
	    procedure VstupOp(var Typ:byte; var Atom:PChar); virtual;
	    function Copy(AVMemory:PObject):PCompObject; virtual;
	   end;


type PEditFile=^TEditFile;
     TEditFile=object(TFile)
		TextWindow:PFileWindow;
		ParentTextW:PWindowsObject;
		DebugSign:boolean;
		FirstF8:boolean;
		Line:integer;
		IsNewLine:boolean;
		constructor Init(VMemory:PVirtMemory;FileN:PChar;AParentW:PWindowsObject);
		destructor Done; virtual;
		procedure MakeTextWindow;
		procedure CtiRetezec; virtual;
		function CtiZnak(var Znak:char):char; virtual;
                    procedure NaPrvniPlatny;
		procedure SelectLine(Number:integer);
		function Copy(AVMemory:PObject):PCompObject; virtual;
	       end;

type PFileW=^TFileW;
     TFileW=object(TFileWindow)
	     Members:PCollection;
	     constructor Init(AParent:PWindowsObject;AMember:PEditFile;NameF:PChar);
	     destructor Done; virtual;
               procedure FreeMember(EdFile:PEditFile);
	     procedure WMActivate(var Msg:TMessage); virtual wm_First+wm_Activate;
	    end;


implementation


  uses WinTypes, WinProcs, Strings, Hodnoty;

  var Soubor:TDOSStream;


constructor TFileW.Init(AParent:PWIndowsObject;AMember:PEditFile;NameF:PChar);
 begin
  inherited Init(AParent,nil{'Zdrojov text'},NameF);
  Members:=New(Pcollection,Init(5,5));
  Members^.Insert(AMember);
  AMember^.Pridej;
 end;

destructor TFileW.Done;
 procedure UberZivot(A:PEditFile); far;
  begin
   A^.TextWindow:=nil;
   SendMessage(Parent^.HWindow,wm_User+wm_WinClosed,3,Longint(A));
  end;
 begin
  Members^.forEach(@UberZivot);
  Members^.DeleteAll;
  dispose(Members,Done);
  inherited Done;
 end;

procedure TFileW.WMActivate(var Msg:TMessage);
{ Pi aktivaci editanho okna zdrojovho textu }
{ se pepne input pro lexikln analyztor      }
 var MemD:TMemdescr;
 begin
  if (Msg.wParam=WA_Active)or(Msg.wParam=WA_ClickActive) then
   begin
    inherited WMActivate(Msg);
    MemD:=PVirtMemory(PEditFile(Members^.At(0))^.VMem)^.GetMemDescr(Members^.At(0));
    SendMessage(Parent^.Hwindow,wm_User+wm_WinClosed,4,longint(MemD));
   end else inherited WMActivate(Msg);
 end;

procedure TFileW.FreeMember(EdFile:PEditFile);
 var idx:word;
 begin
   begin
    idx:=0;
    while Members^.At(idx)<>EdFile do inc(idx);
    Members^.AtDelete(idx);
   end;
 end;

constructor TFile.Init(VMemory:PVirtMemory;FileN:PChar);
 begin
  inherited Init(VMemory);
  COTyp:=sco_File;
  strcopy(Jmeno,FileN);
  strcopy(TextBuff,'');
  Mode:=stOpen;
  Konec:=FALSE;
  FileDescr.Init(FileN,stOpen);
  EdF:=cmd_File;
 end;

destructor TFile.Done;
 begin
  FileDescr.Done;
  inherited Done;
 end;

function TFile.Copy(AVMemory:PObject):PCompObject;
 var B:PFile;
 begin
  B:=new(PFile,Init(PVirtMemory(VMem),Jmeno));
  B^.FileDescr.Seek(FileDescr.GetPos);
  B^.Konec:=Konec;
  B^.Mode:=Mode;
  B^.TextBuff:=TextBuff;
  B^.VMem:=AVMemory;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;

constructor TEditFile.Init(VMemory:PVirtMemory;FileN:PChar;AParentW:PWindowsObject);
 function Childs(A:PFileW):boolean; far;
  var Text:array [0..100] of char;
  begin
   GetWindowText(A^.HWindow,Text,100);
   Childs:=StrComp(Text,FileN)=0;
  end;
 begin
  inherited Init(VMemory,FileN);
  Textwindow:=PFileW(Application^.MainWindow^.firstThat(@Childs));
  if TextWindow<>nil then begin
                           PFileW(TextWindow)^.Members^.Insert(@Self);
                           Self.Pridej;
                          end;
  ParentTextW:=AParentW;
  DebugSign:=true;
  FirstF8:=true;
  Line:=0;
  IsNewLine:=false;
  EdF:=cmd_EditFile;
 end;

destructor TEditFile.Done;
 begin
  if TextWindow<>nil then PFileW(TextWindow)^.FreeMember(@Self);
  inherited Done;
 end;

function TEditFile.Copy(AVMemory:PObject):PCompObject;
 var B:PEditFile;
 begin
  B:=new(PEditFile,Init(PVirtMemory(AVMemory),Jmeno,ParentTextW));
  B^.FileDescr.Seek(FileDescr.GetPos);
  B^.Konec:=Konec;
  B^.Mode:=Mode;
  B^.TextBuff:=TextBuff;
  B^.ParentTextW:=ParentTextW;
  B^.DebugSign:=DebugSign;
  B^.FirstF8:=FirstF8;
  B^.Line:=Line;
  B^.IsNewLine:=IsNewLine;
  B^.Kolik:=Kolik;
  Copy:=B;
 end;

procedure TEditFile.MakeTextWindow;
 begin
  TextWindow:=new(PFileW,Init(ParentTextW,@Self,Jmeno));
  Application^.MakeWindow(TextWindow);
 end;

procedure CistiKonecRadky(S:PChar);
 var i:word;
 begin
  i:=0;
  while S[i]<>#0 do inc(i);
  if i<>0 then
   begin
    dec(i);
    while s[i] in [' ',#10,#13,Tabel] do
     begin
      if s[i]<>#10 then s[i]:=#13;
      dec(i);
     end;
   end;
 end;

procedure TEditFile.CtiRetezec;
   var BuffRadek:string;
       Radek:PChar;
       XStr:array [0..1] of char;
       Vysl:longint;
   begin
       if Line>=TextWindow^.Editor^.GetNumLines
	then Konec:=true
	else
	 begin
	  TextWindow^.Editor^.GetLine(Textbuff,1023,Line);
	  StrCat(TextBuff,#$0d#$0a);
	  CistiKonecRadky(TextBuff);
	  inc(Line);
	 end
   end;

function TEditFile.CtiZnak(var Znak:char):char;
   var Radek:PChar;
       i:word;
   begin
    if Textwindow=nil then MakeTextwindow;
    Radek:=TextBuff;
    if Radek[0]=#$0d then
     begin
      IsNewLine:=true;
      Radek[0]:=#$0a;
     end;
    if Radek[0]=#0 then CtiRetezec;
    if Konec then exit;
    Znak:=char(Radek^);
    CtiZnak:=Znak;
    for i:=1 to sizeof(TextBuff)-1 do TextBuff[i-1]:=TextBuff[i];
   end;

procedure TEditFile.SelectLine(Number:integer);
 var BegPos,LenLine:integer;
 begin
  if Textwindow=nil then MakeTextwindow;
  BegPos:=TextWindow^.Editor^.GetLineIndex(Number);
  LenLine:=TextWindow^.Editor^.GetLineLength(Number);
  TextWindow^.Editor^.SetSelection(BegPos+LenLine,BegPos);
 end;


procedure TEditFile.NaPrvniPlatny;
 var Znak:char;
 label OnceMore;
 begin
  OnceMore:

    while (not(Konec)and((CtiZnak(Znak)=' ')or(Znak=Tabel)or(Znak=#13)or(Znak=#10))) do;

    if Konec then begin
	         exit;
	        end;

    if (Znak='%') then
     begin
      while not(Konec)and(CtiZnak(Znak)<>#10) do;
      if not Konec then goto OnceMore;
     end;

    if Konec then begin
                   exit;
                  end;

    VratZnak(Znak);
    IsNewLine:=false;
 end;





{****************************************************************** }
{ Naten etzce z textovho souboru }


   procedure TFile.CtiRetezec;


   var BuffRadek:string;
       Radek:PChar;
       XStr:array [0..1] of char;
       Vysl:longint;
   begin
    Vysl:=FileDescr.GetSize-FileDescr.GetPos;
    if Vysl=0 then begin
			 Konec:=true;
			 FileDescr.Done;
                        end
		   else begin
			 Konec:=false;
			 if Vysl>100 then
			  begin
			   FileDescr.Read(TextBuff,100);
			   TextBuff[100]:=#0;
			  end
				    else
			  begin
			   FileDescr.Read(TextBuff, Vysl);
			   TextBuff[Vysl]:=#0;
			  end;
			end;
   end;
{****************************************************************** }



{****************************************************************** }
{ Naten znaku pro analzu }


  function TFile.CtiZnak(var Znak:char):char;

   { Parametry: Soub  - vstupn zdrojov text v Postscriptu    }
   {            Znak  - znak naten ze zdrojovho textu       }
   {            Konec - konec zdrojoveho textu                 }

   var Radek:PChar;
       i:word;

   begin
    Radek:=TextBuff;
    if Radek[0]=#0 then CtiRetezec;
    if Konec then exit;
    Znak:=char(Radek^);
    CtiZnak:=Znak;
    for i:=1 to sizeof(TextBuff)-1 do TextBuff[i-1]:=TextBuff[i];
   end;
{****************************************************************** }



{****************************************************************** }
{ Vrcen znaku do vstupnho etzce }


  procedure TFile.VratZnak(var Znak:char);

   { Parametry:   Znak  - znak vracen do zdrojovho textu       }

   var i:word;

   begin
    for i:=sizeof(TextBuff)-1 downto 1 do TextBuff[i]:=TextBuff[i-1];
    TextBuff[0]:=Znak;
   end;

{****************************************************************** }

  function Hexa(Znak:char):boolean;
   begin
    Hexa:= Znak in ['0','1','2','3','4','5','6','7','8','9','a','A','b','B','c','C','d','D','e','E','f','F'];
   end;

  function Oddelovac(Znak:char):boolean;
   begin
    Oddelovac:=Znak in [' ',Tabel,#10, #13, '%','(',')','<','>','[',']','{','}','=','/'];
   end;



{****************************************************************** }
{ Naten jednoho opertoru Postscriptu a jeho analza              }

  procedure TFile.VstupOp(var Typ:byte; var Atom:PChar);

  { Parametry: Typ  - typ atomick formule                 }
  {            Atom - ukazetel na etzec atomick formule }

  {          Typ atomicke formule:

  {          1 ... cislo typu integer
  {          2 ... cislo typu real
  {          3 ... jmeno
  {          4 ... retezec
  {          5 ... [
  {          6 ... ]
  {          7 ... {
  {          8 ... }
  {          9 ... /
  {         10 ... =
  {         11 ... cele cislo ve specifikovane soustave
  {         12 ... retezec slozeny z kodu                  }


   label OnceMore1, OnceMore2;

   var Znak:char;
       i:integer;
       XRet:array [0..1] of char;

  function VstupCisla(var Atom:PChar; var Znak:char; var Typ:byte):byte;

   var XRet:array [0..1] of char;

   begin { function }
    XRet[1]:=#0;
    if (Znak='+')or(Znak='-')or((Znak>='0')and(Znak<='9'))or(Znak='.') then
     begin { if 1 }
	if Znak<>'.' then begin char(XRet[0]):=Znak;Atom:=strcat(Atom,XRet) end
		     else VratZnak(Znak);
	while not(Konec) and ((CtiZnak(Znak)>='0') and (Znak<='9')) do
	 begin { while 1}
	  char(XRet[0]):=Znak;
	  Atom:=strcat(Atom,XRet);
	 end;  { while 1}
	if Konec then
	 begin { if 2 }
	  Typ:=ct_Integer;
	  VstupCisla:=ct_Integer;
	  exit;
	 end;  { if 2 }
	if Oddelovac(Znak) then
	 begin { if 2 }
	  VratZnak(Znak);
	  Typ:=ct_Integer;
	  VstupCisla:=ct_Integer;
	  exit;
	 end;  { if 2 }
      case Znak of
       '#':begin { case '#' }
	    XRet[0]:=Znak;
	    Atom:=strcat(Atom,XRet);
	    while not(Konec) and ((CtiZnak(Znak)>='0')and(Znak<='9')) do
	     begin { while }
	      XRet[0]:=Znak;
	      Atom:=strcat(Atom,XRet);
	     end;  { while }
	    if Konec then
	     begin
	      Typ:=11;
	      VstupCisla:=11;
	      exit
	     end;
	    if Oddelovac(Znak) then
	     begin
	      VratZnak(Znak);
	      Typ:=11;
	      VstupCisla:=11;
	      exit;
	     end               else
	     begin
	      VratZnak(Znak);
	      Typ:=err_syntaxerror;
	      VstupCisla:=err_syntaxerror;
	      exit;
	     end;
	   end;  { case '#' }
       '.':begin { case '.' }
	    XRet[0]:=Znak;
	    Atom:=strcat(Atom,XRet);
	    while not(Konec) and ((CtiZnak(Znak)>='0')and(Znak<='9')) do
	     begin { while }
	      XRet[0]:=Znak;
	      Atom:=strcat(Atom,XRet);
	     end;  { while }
	    if Konec then
	     begin
	      Typ:=ct_Real;
	      VstupCisla:=ct_Real;
	      exit;
	     end;
	    if oddelovac(Znak) then
	     begin
	      VratZnak(Znak);
	      Typ:=ct_Real;
	      VstupCisla:=ct_Real;
	      exit;
	     end               else
	     if (Znak='E') or (Znak='e') then
	      if not(Konec) and ((CtiZnak(Znak)='+')or(Znak='-')or((Znak>='0')and(Znak<='9'))) then
	       begin
		while not(Konec) and ((CtiZnak(Znak)>='0')and(Znak<='9')) do
		 begin { while }
		  XRet[0]:=Znak;
		  Atom:=strcat(Atom,XRet);
		 end;  { while }
		if Konec then
		 begin { if }
		  Typ:=ct_Real;
		  VstupCisla:=ct_Real;
		  exit;
		 end;  { if }
		if Oddelovac(Znak) then
		 begin { if }
		  VratZnak(Znak);
		  Typ:=ct_Real;
		  VstupCisla:=ct_Real;
		  exit;
		 end   { if }     else
		 begin { else }
		  VratZnak(Znak);
		  Typ:=err_syntaxerror;
		  VstupCisla:=err_syntaxerror;
		  exit;
		 end;  { else }
	       end
	      else
	      begin
	       if Konec then
		begin
		 Typ:=err_syntaxerror;
		 VstupCisla:=err_syntaxerror;
		 exit;
		end     else
		begin
		 VratZnak(Znak);
		 Typ:=err_syntaxerror;
		 VstupCisla:=err_syntaxerror;
		 exit;
		end;
	      end;
	   end;  { case '.' }
       'E','e':begin { case 'E','e' }
		XRet[0]:=Znak;
		Atom:=strcat(Atom,XRet);
		if not(Konec)and((CtiZnak(Znak)='+')or(Znak='-')or((Znak>='0')and(Znak<='9'))) then
		 begin { if }
		  XRet[0]:=Znak;
		  Atom:=strcat(Atom,XRet);
		 end;  { if }
		 if Konec then
		  begin { if }
		   Typ:=ct_Real;
		   VstupCisla:=ct_Real;
		   exit;
		  end;  { if }
		 if Oddelovac(Znak) then
		  begin { if }
		   VratZnak(Znak);
		   Typ:=ct_Real;
		   VstupCisla:=ct_Real;
		   exit;
		  end   { if }      else
		  begin { else }
		   if Konec then
		    begin { if 1 }
		     Typ:=err_syntaxerror;
		     VstupCisla:=err_syntaxerror;
		     exit;
		    end   { if 1 } else
		    begin { else 1 }
		     VratZnak(Znak);
		     Typ:=err_syntaxerror;
		     VstupCisla:=err_syntaxerror;
		     exit;
                    end;  { else 1 }
                  end;  { else }
	       end  { case 'E','e' }
	 else begin { default }
	       VratZnak(Znak);
	       Typ:=err_syntaxerror;
	       VstupCisla:=err_syntaxerror;
	       exit;
	      end;  { default }
      end;  { case Znak }
       end;  { if 1 }
    Typ:=err_syntaxerror;
    VstupCisla:=err_syntaxerror;
   end;  { function }


   begin
    XRet[1]:=#0;
    Atom:=Retezec;
    strpcopy(Atom,'');

    { --------------------------------------------------- }

    OnceMore1:

    while (not(Konec)and((CtiZnak(Znak)=' ')or(Znak=Tabel)or(Znak=#13)or(Znak=#10))) do;

    if Konec then begin
	         Typ:=err_endoffile;
	         exit;
	        end;

    if (Znak='%') then
     begin
      while not(Konec)and(CtiZnak(Znak)<>#10) do;
      if not Konec then goto OnceMore1;
     end;

    if Konec then begin
	         Typ:=err_endoffile;
                   exit;
                  end;

    { --------------------------------------------------- }


    Typ:=VstupCisla(Atom,Znak,Typ);

    if Typ<>err_syntaxerror then goto OnceMore2
    else if (Znak='(') then
	  begin
	   while not(Konec)and(CtiZnak(Znak)<>')') do
            begin
	   XRet[0]:=Znak;
             Atom:=strcat(Atom,XRet);
            end;
           if Konec then begin
                          Typ:=err_syntaxerror;
                          exit;
                         end;
             Typ:=ct_String;
	   goto OnceMore2;
	  end
    else if (Znak='<') then
	  begin
	   while not(Konec)and(CtiZnak(Znak)<>'>') do
            begin
             if Konec then
              begin
               Typ:=err_syntaxerror;
               exit;
              end;
	     if Hexa(Znak) then begin
			     XRet[0]:=Znak;
                                   Atom:=strcat(Atom,XRet);
			    end
                           else begin
                                 Typ:=err_syntaxerror;
                                 goto OnceMore2;
                                end;

            end;
	   Typ:=12;
	   goto OnceMore2;
	  end
    else case Znak of
	  '[':begin
               Typ:=5;
               goto OnceMore2;
              end;
          ']':begin
               Typ:=6;
               goto OnceMore2;
              end;
	  '{':begin
	       Typ:=7;
                 goto OnceMore2;
	      end;
          '}':begin
               Typ:=8;
               goto OnceMore2;
	    end;
          '/':begin
	       CtiZnak(Znak);
               if Znak='/' then
		begin { Primo substituovane jmeno }
		 VstupOp(Typ,Atom);
                 if Typ=ct_Name then Typ:=ct_SubstName
                                else Typ:=err_Lexikal;
                 goto OnceMore2;
		end        else VratZnak(Znak);
	       VstupOp(Typ,Atom);
               if Typ=ct_Name then Typ:=ct_LitName
                              else Typ:=err_Lexikal;
               goto OnceMore2;
              end;
	  '=':begin
	       Typ:=10;
                 goto OnceMore2;
                 end;
	  else begin
                if Oddelovac(Znak) then begin
                                         Typ:=err_syntaxerror;
                                         exit;
                                        end;
                while not(Oddelovac(Znak)) and not(Konec) do
		 begin
                      XRet[0]:=Znak;
		  Atom:=strcat(Atom,XRet);
		  CtiZnak(Znak);
		 end;
		VratZnak(Znak);
                Typ:=3;
                goto OnceMore2;
               end;
         end;

  { --------------------------------------------------------- }

   OnceMore2:

    while (not(Konec)and((CtiZnak(Znak)=' ')or(Znak=Tabel)or(Znak=#13)or(Znak=#10))) do;

    if Konec then begin
	         exit;
	        end;

    if (Znak='%') then
     begin
      while not(Konec)and(CtiZnak(Znak)<>#10) do;
      if not Konec then goto OnceMore2;
     end;

    if Konec then begin
                   exit;
                  end;

    VratZnak(Znak);

  { --------------------------------------------------------- }

   end;

{****************************************************************** }

end.