{ Nevyeen problmy:                             }
{ Konverze je zatm v innosti pouze pro kd 1..3, 5, 7, 8, 9}
{ Pi konverzi typu 3 se alokuje pam, kter se potom neuvoln }

unit Konverze;

{   Softwarov emulace poscriptu   }
{   Modul konverze datovch typ   }
{    Tom Mayer(C) 1993           }

{$N+}
{$E+}


interface

uses Zasobnik, Strings, OMemory, Win31, Hodnoty, ObjKomp;

type PPChar=^TPChar;
     TPChar=array [0..255] of char;

function AtomToDat(VMemory:PvirtMemory; XTyp:byte; Atom:PChar; var PolZas:TPolZas):byte;

procedure BehToDat(XTyp:byte; Adr1,Adr2:TMemDescr; var PolBehZas:TPolBehZas);

function FixedToReal(AFixed:TFixed):TReal;


implementation

function AtomToDat(VMemory:PVirtMemory; XTyp:byte; Atom:PChar; var PolZas:TPolZas):byte;

var Chyba:integer;
    Text:TPChar;

 begin { Function }
  with PolZas do
   begin { with PolZas }
    case XTyp of
     ct_Integer:begin { case 1 }
                 Typ:=ct_Integer;
                 Val(StrPas(Atom),HLongint,Chyba);
		 AtomTodat:=Chyba;
                 { Chyba pri prevodu nenastane - format cisla kontroluje lex. analyzator }
		 exit;
                end;  { case 1 }
     ct_Real:begin { case 2 }
              Typ:=ct_Real;
              Val(StrPas(Atom),HReal,Chyba);
	      AtomToDat:=Chyba;
              { Chyba pri prevodu nenastane - format cisla kontroluje lex. analyzator }
              exit;
             end;  { case 2 }
     ct_Name:begin { case 3 }
              Typ:=ct_Name;
	      VMemory^.Alloc(new(PRet,Init(VMemory,Atom,strlen(Atom))),HPRet);
	      AtomToDat:=0;
	      exit;
	     end;  { case 3 }
     ct_String:begin { case 4 }
		Typ:=ct_String;
		VMemory^.Alloc(new(PRet,Init(VMemory,Atom,strlen(Atom))),HPRet);
		AtomToDat:=0;
	       end;  { case 4 }
     ct_Mark:begin { case 5 }
              Typ:=ct_Mark;
             end;  { case 5 }
     ct_BackBrack:begin { case 6 }
                   Typ:=ct_BackBrack;
                  end;  { case 6 }
     ct_BracProc:begin { case 7 }
		  Typ:=7;
                 end;  { case 7 }
     ct_BackBrackProc:begin { case 8 }
                       Typ:=ct_BackBrackProc;
                      end;  { case 8 }
     ct_LitName:begin
                 Typ:=ct_LitName;
		 VMemory^.Alloc(new(PRet,Init(VMemory,Atom,strlen(Atom))),HPRet);
                 AtomToDat:=0;
		end;
     ct_SubstName:begin
                   Typ:=ct_SubstName;
		   VMemory^.Alloc(new(PRet,Init(VMemory,Atom,strlen(Atom))),HPRet);
                   AtomToDat:=0;
                   end;
     else AtomToDat:=err_Lexikal;
    end; { case Typ }
   end;  { with PolZas }
 end;  { Function }



 procedure BehToDat(XTyp:byte; Adr1,Adr2:TMemDescr; var PolBehZas:TPolBehZas);

  begin { Procedure }
   with PolBehZas do
    begin
     Typ:=XTyp;
     Uk1.Uk:=Adr1;
     Uk2.Uk:=Adr2;
    end;
  end;  { Procedure }

function FixedToReal(AFixed:TFixed):TReal;
 begin { FixedToReal }
  with AFixed do
   FixedToReal:=Value+Fract/65536;
 end;  { FixedToReal }

 end. { of Unit }