{ Nevyeen problmy:                           }
{ Zatm se neobjevily                            }

unit Zasobnik;

interface

uses Objects,WinTypes, WinProcs, OWindows, ODialogs, Strings, Slovniky,
     Hodnoty, ObjKomp, Chyby, Lexikal;

const VelMaxZas=500;    { Velikost zsobnku opertor }
      VelMaxBehZas=250; { Velikost bhovho zsobnku }

type TPolZas=record Typ:byte;
		    case integer of
		     0:(Whole:TWhole);
		     1:(Uk:TMemDescr);
		     2:(W1,W2:word);
		     3:(HLongint:longint);
		     4:(HReal:TReal);
		     5:(HPRet:TMemDescr);
		     6:(HPProc:TMemDescr);
		     7:(HBoolean:boolean);
		     8:(HPFile:TMemDescr);
		     9:(HPDict:TMemDescr);
		    10:(HPCompObject:TMemDescr);
		    11:(HPFont:TMemDescr);
                        12:(HPMatrix:TMemDescr);
	     end;

     PZasobnik=^TZasobnik;
     TZasobnik=object(TObject)
		VMem:PVirtMemory;
		AktPoz:word;
		POBox:array [0..VelMaxZas] of TPolZas;
		constructor Init(VMemory:PVirtMemory);
		function Vloz(Pol:TPolZas):bool;
		function Vyber(var Pol:TPolZas):bool;
		function Copy(VMemory:PVirtMemory):PZasobnik; virtual;
	       end;

     TPolBehZas=record Typ:byte;
		       Uk1:TPolzas;
		       Uk2:TPolZas;
		end;

     PBehZasobnik=^TBehZasobnik;
     TBehZasobnik=object(TObject)
		   VMem:PVirtMemory;
		   AktPoz:word;
		   POBox:array [0..VelMaxBehZas] of TPolBehZas;
		   constructor Init(VMemory:PVirtMemory);
		   function Vloz(Pol:TPolBehZas):bool;
		   function Vyber(var Pol:TPolBehZas):bool;
		   function Copy(VMemory:PVirtMemory):PBehZasobnik; virtual;
		  end;


     PWinZas=^TWinZas;
     TWinZas=object(TWindow)
	      ListWindow:PListBox;
	      Zasobnik:PZasobnik;
	      constructor Init(AParent:PWindowsObject; Zas:PZasobnik);
	      destructor Done; virtual;
	      procedure WMSize(var Msg:TMessage); virtual WM_FIRST+WM_SIZE;
	      procedure Seznam(VMem:PVirtMemory);
	     end;

     PWinBehZas=^TWinBehZas;
     TWinBehZas=object(TWindow)
		 ListWindow:PListBox;
		 Zasobnik:PBehZasobnik;
		 constructor Init(AParent:PWindowsObject; Zas:PBehZasobnik);
		 destructor Done; virtual;
		 procedure WMSize(var Msg:TMessage); virtual WM_FIRST+WM_SIZE;
		 procedure Seznam(VMem:PVirtMemory);
		end;


var SlovnikovyZasobnik:PSlovZas;

implementation

constructor TWinZas.Init(AParent:PWindowsObject; Zas:PZasobnik);
var  Textik:array [0..100] of char;
     i:byte;
     Text:PChar;
 begin
  inherited Init(AParent,'Operand stack');
  ListWindow:=new(PListBox,Init(@Self,101,10,10,150,200));
  Listwindow^.Attr.Style:=ListWindow^.Attr.Style and not lbs_sort;
  Zasobnik:=Zas;
 end;

destructor TWinZas.Done;
 begin
  dispose(ListWindow,Done);
  SendMessage(Parent^.HWindow,wm_User+wm_WinClosed,1,0);
  inherited Done;
 end;

procedure TWinZas.WMSize(var Msg:TMessage);
 begin
  TWindow.WMSize(Msg);
  with Msg do SetWindowPos(ListWindow^.HWindow,0,10,10,LParamLo-20,LParamHi-20,0);
 end;

 procedure TWinZas.Seznam(VMem:PVirtMemory);
 var Hodn:record Cislo:word;
		   Typ:word;
		 case integer of
		  1:(HLongint:longint);
		  2:(HSingle:real);
		  3:(HWord1,HWord2:word);
		  4:(HPChar:PChar);
		  5:(HBoolean:Boolean);
		  6:(HPFile:PFile);
                      70:(NOperator:longint);
	  end;
     EditPChar:array [0..100] of char;
     Textik:array [0..100] of char;
     StrPom:string;
     i:word;
     Text:PChar;
     P:TPolozka;
 begin
  ListWindow^.ClearList;
  if Zasobnik^.AktPoz<>0 then
   begin
    for i:=Zasobnik^.AktPoz downto 1 do
		    begin
		     Hodn.Cislo:=i;
		     Hodn.Typ:=Zasobnik^.POBox[i].Typ;
		     Text:=Textik;
		     case Hodn.Typ of
		     ct_Integer:begin { integer }
                                 Hodn.HLongint:=Zasobnik^.POBox[i].HLongint;
                                 WVSPrintF(Text,'%d ... %d = %li',Hodn);
				end;
                     ct_Real:begin { real }
                              str(Zasobnik^.POBox[i].HReal:8:3,StrPom);
			      StrPCopy(EditPChar,StrPom);
			      Hodn.HPChar:=EditPChar;
			      WVSPrintF(Text,'%d ... %d = %s',Hodn);
                             end;  { real }
                     ct_Name:begin { name }
			      Hodn.HPChar:=PRet(VMem^.GetPointer(Zasobnik^.POBox[i].HPRet))^.Box;
			      WVSPrintF(Text,'%d ... %d = %s',Hodn);
			     end;
		     ct_String:begin { string }
				Hodn.HPChar:=PRet(VMem^.GetPointer(Zasobnik^.POBox[i].HPRet))^.Box;
				WVSPrintF(Text,'%d ... %d = %s',Hodn);
			       end;
		     ct_SubString:begin { substring }
				   with PRet(VMem^.GetPointer(Zasobnik^.POBOx[i].HPRet))^ do
				    begin
				     move(Box^,EditPChar,Count);
				     if Count>100 then EditPChar[100]:=#0 { zakonceni retezce }
						  else EditPChar[Count]:=#0;
				    end;
				   Hodn.HPChar:=EditPChar;
				   WVSPrintF(Text,'%d ... %d = %s',Hodn);
				  end;
		     ct_Mark:begin { mark }
			      WVSPrintF(Text,'%d ... %d = mark',Hodn);
			     end;
		     ct_LitName:begin { literal name }
				 Hodn.HPChar:=PRet(VMem^.GetPointer(Zasobnik^.POBox[i].HPret))^.Box;
				 WVSPrintF(Text,'%d ... %d = %s',Hodn);
				end;
                     ct_Dict:begin { dict }
			      Hodn.HLongint:=Zasobnik^.POBox[i].Uk;
                              WVSPrintF(Text,'%d ... %d = dict %li',Hodn);
                             end;
                     ct_ImpProc:begin { dict }
			      Hodn.NOperator:=Zasobnik^.POBOx[i].Uk;
                                    WVSPrintF(Text,'%d ... %d = operator %li',Hodn);
                                end;
		     ct_Logic:begin { logical }
			       Hodn.HPChar:=nil;
			       if Zasobnik^.POBox[i].HBoolean then
                                WVSPrintF(Text,'%d ... %d = true',Hodn)
							      else
                                WVSPrintF(Text,'%d ... %d = false',Hodn);
			      end;
                      else WVSPrintF(Text,'%d ... %d',Hodn);
		     end;
		     ListWindow^.AddString(Text);
		    end
   end
			  else
		    begin
		     StrCopy(Textik,'Operand stack is empty');
		     Text:=Textik;
		     ListWindow^.AddString(Text);
		    end;
 end;

constructor TWinBehZas.Init(AParent:PWindowsObject; Zas:PBehZasobnik);
 begin
  inherited Init(AParent,'Executable stack');
  ListWindow:=new(PListBox,Init(@Self,101,10,10,150,200));
  Listwindow^.Attr.Style:=ListWindow^.Attr.Style and not lbs_sort;
  Zasobnik:=Zas;
 end;

 destructor TWinBehZas.Done;
  begin
   dispose(ListWindow,Done);
   SendMessage(Parent^.HWindow,wm_User+wm_WinClosed,2,0);
   inherited Done;
  end;

procedure TWinBehZas.WMSize(var Msg:TMessage);
 begin
  TWindow.WMSize(Msg);
  with Msg do SetWindowPos(ListWindow^.HWindow,0,10,10,LParamLo-20,LParamHi-20,0);
 end;

 procedure TWinBehZas.Seznam;
 var Hodn:record Cislo:word;
		   Typ:word;
		 case integer of
		  1:(HLongint:longint;)
	  end;
     Textik:array [0..100] of char;
     i:byte;
     Text:PChar;
 begin
  ListWindow^.ClearList;
  if Zasobnik^.AktPoz<>0 then
   begin
    for i:=Zasobnik^.AktPoz downto 1 do
		    begin
		     Hodn.Cislo:=i;
		     Hodn.Typ:=Zasobnik^.POBox[i].Typ;
		     Text:=Textik;
		     WVSPrintF(Text,'%d ... %d',Hodn);
		     ListWindow^.AddString(Text);
		    end
   end
			  else
		    begin
		     StrCopy(Textik,'Executable stack is emtpy');
		     Text:=Textik;
		     ListWindow^.AddString(Text);
		    end;
 end;


constructor TZasobnik.Init(VMemory:PVirtMemory);
 begin
  inherited Init;
  VMem:=VMemory;
  AktPoz:=0;
 end;

function TZasobnik.Copy(VMemory:PVirtMemory):PZasobnik;
 var X:PZasobnik;
 begin
  X:=new(PZasobnik,Init(VMemory));
  X^.AktPoz:=AktPoz;
  X^.POBox:=POBOx;
  Copy:=X;
 end;

function TZasobnik.Vloz(Pol:TPolZas):bool;
 begin
  if AktPoz<VelMaxZas then
   begin { if 1 }
    inc(AktPoz);
    with Pol do IncLife(VMem,Typ,HPCompObject);
    POBox[AktPoz]:=Pol;
    Vloz:=true;
   end   { if 1 }     else
   begin { else 1 }
    ErrorHandle^.NewValue('OPERAND STACK',err_stackoverflow); { indikace chyby preteceni zasobniku }
    Vloz:=false;
   end;  { else 1 }
 end;

function TZasobnik.Vyber(var Pol:TPolZas):bool;
 begin
  if AktPoz>0 then
   begin { if 1 }
    Pol:=POBOX[AktPoz];
    dec(AktPoz);
    with Pol do DecLife(VMem,Typ, HPCompObject);
    Vyber:=true;
   end   { if 1 }
              else
   begin { else 1 }
    ErrorHandle^.NewValue('OPERAND STACK',err_stackunderflow); { indikace chyby podteceni zasobniku }
    Vyber:=false;
   end;  { else 1 }
 end;

constructor TBehZasobnik.Init(VMemory:PVirtMemory);
 begin
  inherited Init;
  VMem:=VMemory;
  AktPoz:=0;
 end;

function TBehZasobnik.Copy(VMemory:PVirtMemory):PBehZasobnik;
 var X:PBehZasobnik;
 begin
  X:=new(PBehZasobnik,Init(VMemory));
  X^.AktPOz:=AktPoz;
  X^.PoBox:=PoBox;
  Copy:=X;
 end;

function TBehZasobnik.Vloz(Pol:TPolBehZas):bool;
 begin
  if AktPoz<VelMaxZas then
   begin { if 1 }
    inc(AktPoz);
    POBox[AktPoz]:=Pol;
    if (Pol.Typ=ct_Proc)or(Pol.Typ=ct_LoopCyklus) then with Pol.Uk1 do IncLife(VMem,Pol.Typ,HPCompObject);
    Vloz:=true;
   end   { if 1 }     else
   begin { else 1 }
    ErrorHandle^.NewValue('EXEC STACK',err_execstackoverflow); { indikace chyby preteceni proceduralniho zasobniku }
    Vloz:=false;
   end;  { else 1 }
 end;

function TBehZasobnik.Vyber(var Pol:TPolBehZas):bool;
 begin
  if AktPoz>0 then
   begin { if 1 }
    Pol:=POBOX[AktPoz];
    if (Pol.Typ=ct_Proc)or(Pol.Typ=ct_LoopCyklus) then with Pol.Uk1 do DecLife(VMem,Pol.Typ,HPCompObject);
    dec(AktPoz);
    Vyber:=true;
   end   { if 1 }
              else
   begin { else 1 }
    ErrorHandle^.NewValue('EXEC STACK',err_execstackunderflow); { chyba podteceni proceduralniho zasobniku }
    Vyber:=false;
   end;  { else 1 }
 end;


end.